/***********************************************************
	PROGRAM:	pictps
	MODULE:		externs.c

	AUTHOR:		Patrick Hayden
	DATE:		1991-10-29

************************************************************/

#include "pictps.h"

/* Version info */
float			version = 1.3;
unsigned 		revision = 0;

char			*ifilename, load_path[_POSIX_PATH_MAX], tbuf[_POSIX_PATH_MAX];

/* Info pertaining to link pictures */
unsigned 		num_links = 0, links[MAX_LINKS], pict_id;

/* Options and status */
unsigned short int	options = 0x0000;
unsigned short int 	flags = 0x0000;

/* Hack hack hack... */
unsigned short int drsikes = 0;

char			*annotate_string;
char 			*palette_file;

int 			bcol;
BOX 			pict_size;

char            path[281];
unsigned        paper = 0;
FXY_AREA        margin = { 36, 36, 36, 36 };

ELEMENT_DATA  	*data;
LABEL_DATA 		*label;
TRANSFORM_DATA 	*transform;

HDR				*group_hdr[MAX_GROUP_NEST+1];
int				group_level = -1;
GROUP_ELEMENT	*group_element;

int 			display_pid;

struct drawing_at	current_point;

struct wind_struct wind;

unsigned short	num_fonts;
union ufont font[MAX_FONT+1];

/* Paper info ( %1 == landscape ) */

struct paper_size paper_sizes[NUM_PAPER_SIZES] = {
    "Standard",             612,    792,
    "Standard Landscape",   792,   	612,
    "Legal",                612,    1008,
    "Legal Landscape",      1008,   612
};

/* Default rgb mapping */

struct rgb rgb_map[MAX_COLOUR+1] = {
	-1.00, -1.00, -1.00,
	0.000, 0.000, 0.000,
	0.781, 0.781, 0.781,
	0.625, 0.625, 0.625,
	0.312, 0.312, 0.312,
	1.000, 1.000, 1.000,
	0.453, 0.719, 0.640,
	0.324, 0.500, 0.375,
	0.000, 0.660, 0.000,
	1.000, 1.000, 0.656,
	1.000, 1.000, 0.000,
	0.930, 0.906, 0.801,
	0.656, 0.324, 0.656,
	1.000, 0.640, 0.640,
	1.000, 0.000, 0.000,
	0.000, 0.000, 0.656,
	0.418, 0.527, 1.000
};


unsigned char char_map[256] = {
  0,      32,     32,     3,      4,      5,      6,      7,
  32,     32,     32,     32,     32,     32,     32,     32,
  32,     32,     32,     32,     0266,   0247,   32,     32,
  18,     19,     32,     32,     32,     32,     32,     32,
  32,     33,     34,     35,     36,     37,     38,     39,
  40,     41,     42,     43,     44,     45,     46,     47,
  48,     49,     50,     51,     52,     53,     54,     55,
  56,     57,     58,     59,     60,     61,     62,     63,
  64,     65,     66,     67,     68,     69,     70,     71,
  72,     73,     74,     75,     76,     77,     78,     79,
  80,     81,     82,     83,     84,     85,     86,     87,
  88,     89,     90,     91,     92,     93,     94,     95,
  96,     97,     98,     99,     100,    101,    102,    103,
  104,    105,    106,    107,    108,    109,    110,    111,
  112,    113,    114,    115,    116,    117,    118,    119,
  120,    121,    122,    123,    0246,   32,     126,    127,
  0307,   0374,   0351,   0342,   0344,   0340,   0345,   0347,
  0352,   0353,   0350,   0357,   0356,   0354,   0304,   0305,
  0311,   0346,   0306,   0364,   0366,   0362,   0373,   0371,
  0377,   0326,   0334,   0242,   0243,   0245,   32,     0243,
  0341,   0355,   0363,   0372,   0361,   0321,   0252,   0272,
  0277,   32,     0254,   0275,   0274,   0241,   0253,   0273,
  32,     32,     32,     32,     32,     32,     32,     32,
  32,     32,     32,     32,     32,     32,     32,     32,
  32,     32,     32,     32,     32,     32,     32,     32,
  32,     32,     32,     32,     32,     32,     32,     32,
  32,     32,     32,     32,     32,     32,     32,     32,
  32,     32,     32,     32,     32,     32,     32,     32,
  32,     32,     32,     32,     32,     32,     0265,   32,
  32,     32,     32,     32,     32,     32,     32,     32,
  32,     0261,   32,     32,     32,     32,     32,     32,
  0260,   32,     32,     32,     32,     0262,   32,     0xff };
