/***********************************************************
    PROGRAM:    pictps
    MODULE:     externs.h

    AUTHOR:     Patrick Hayden
    DATE:       1991-10-29
************************************************************/


extern char			*ifilename;
extern PICTURE_HDR  *hdr;

extern char			path[281];
extern unsigned 	pmode, paper;
extern FXY_AREA 	margin;
extern int 			bcol;
extern short unsigned	num_fonts;
extern union ufont 	font[MAX_FONT+1];

extern float		version;
extern unsigned		revision;

/* Options flags */
#define	OPT_VERBOSE			0x0001
#define OPT_FORCE_BKGD		0x0002
#define OPT_ONE_TO_ONE		0x0004
#define OPT_EPS				0x0008
#define OPT_DISPLAY			0x0010
#define OPT_HELVETICA		0x0020
#define OPT_MIN_EPS			0x0040
#define OPT_BLACK_LINE		0x0080
#define OPT_ANNOTATE		0x0100
#define OPT_SET_PALETTE		0x0200
#define OPT_QUERY_SCREEN	0x0400

extern unsigned short int	options;

/* Status flags */
#define STAT_GRAPHICS		0x0001		/* Graphics Opened */
#define STAT_PICTURE		0x0002		/* Currently printing a picture */
#define STAT_WINDOW			0x0004		/* Currently printing a window */
#define STAT_FRAME			0x0008		/* Currently print a window frame */
#define STAT_SCREEN			0x0010		/* Currently printing a full screen */
#define STAT_PICT			0x0020		/* File is .pict format */
#define STAT_WND			0x0040		/* File is .wnd format */
#define STAT_PRT			0x0080		/* File is .prt format */
#define STAT_SHADOWING		0x0100		/* Object shadow is being drawn */
#define STAT_DIMMING		0x0200      /* Dimmed object is being drawn */
#define STAT_DISPLAYING		0x0400		/* Displaying file while interpreting */
#define STAT_TMPFILE		0x0800		/* Input file is temporary */

extern unsigned short int	flags;

extern unsigned short int	drsikes;

extern char			*annotate_string;
extern char			*palette_file;

extern unsigned 	pict_id;
extern unsigned 	num_links, links[MAX_LINKS];
extern BOX	 		pict_size;
extern char 		tbuf[101];
extern int 			display_pid;

extern ELEMENT_DATA 	*data;
extern LABEL_DATA 		*label;
extern TRANSFORM_DATA 	*transform;

extern HDR				*group_hdr[MAX_GROUP_NEST+1];
extern int				group_level;
extern GROUP_ELEMENT	*group_element;

extern struct paper_size 	paper_sizes[NUM_PAPER_SIZES];
extern struct rgb 			rgb_map[MAX_COLOUR+1];
extern struct drawing_at	current_point;
extern char					*PrologName;
extern unsigned char		char_map[256];


extern struct wind_struct	wind;