/***********************************************************
    PROGRAM:    pictps
    MODULE:     link.c

    AUTHOR:     Patrick Hayden
    DATE:       1991-10-29

    DESCRIPTION:

	Resolve link elements
************************************************************/

#include "pictps.h"
#include "externs.h"

/*--------------------------------------
 	Search existing pictures
	Ask for filename and load a picture
---------------------------------------*/

resolve_link( element, link )
	HDR 			*element;
	LINK_ELEMENT 	*link;
{
	int 	i, pid;	
	char 	filename[80];
	char 	*buf;

	buf = salloc( 8000 );	

	for (i=1;i<=num_links;i++) {
		PictureCurrent(links[i-1]);
		PickElements("T",link->name,1);
		if (CopyElements(NULL,buf,8000,"LT")) {
			draw_link(buf,element,link);
			free(buf);
			return(1);
		}
	}

	if (!(pid = PictureFind(link->pict,"L"))) {
		fprintf(stderr,"\nCould not find picture: %s\n",link->pict);
		fprintf(stderr,"Enter search filename: ");
		fscanf(stdin,"%s",filename);
/*
		if (!(pid=PictureOpen(link->pict,filename,NULL,0,0,NULL,"LR"))) {
			flog("Bad picture file: %s\n",filename);
			free(buf);
			return(0);
		}
*/

		pid = link_open(filename);
	}		

	PictureCurrent(pid);

	if (!CopyElements(link->name,buf,8000,"LT")) {
		flog("Could not copy link element: %s\n",link->name);
		free(buf);
		return(0);
	}

	draw_link(buf,element,link);

	free(buf);
	return( 1 );
/*
	links[num_links] = pid;
	++num_links;
*/

}

STATIC void draw_link( buf, element, link )
	char 			*buf;
	HDR 			*element;
	LINK_ELEMENT 	*link;
{
	HDR *elmt;

	elmt = (HDR *)ElementFirst(buf);	

	memmove(&elmt->row,&element->row,sizeof(RECT_AREA));
	elmt->color = element->color;
	elmt->fill  = element->fill;
	elmt->pattern = element->pattern;
	elmt->flags = element->flags;
	
	if (!link->copy_attr)
		elmt->attr = element->attr;

	Draw_element( elmt );
}

STATIC link_open( fname )
	char *fname;
{
	if ( !( flags & STAT_GRAPHICS ) ) open_graphics( 0 );

	if (num_links >= MAX_LINKS) {
		fprintf(stderr,"Maximum of %d open link pictures\n",MAX_LINKS);
		return(0);
	}

	sprintf(tbuf,"PS%d",num_links);

	if (!(links[num_links]=PictureOpen(tbuf,fname,NULL,0,0,NULL,"LR"))) 
		fprintf(stderr,"Could not open picture: %s\n",fname);
	

	++num_links;

	return( links[num_links-1] );
}
