/***********************************************************
    PROGRAM:    pictps
    MODULE:     number.c

    AUTHOR:     Patrick Hayden
    DATE:       1991-10-29

    DESCRIPTION:

    Picture interpretation code
************************************************************/

#include "pictps.h"
#include "externs.h"

#define INTVAL  number->value.integer
#define REALVAL number->value.real

extern char *trim();

#ifdef min
	#undef min
#endif

static float number_angle();

int text_number=0; //Modif by Guy Grimard(debug text_slider) 

static FXY_AREA 		elmt_xy;
static NUMBER_ELEMENT 	*number;
static HDR 				*element;
static POINT 			pos;
static IRECT_AREA 		temp_area;
static float 			percent;
static int 				i, num_width;
static char 			value_str[70], temp[10];
static bool 			gr, vert;

#if 0

static RECT_AREA		origin;

static unsigned			s_space1,
						s_end,
						s_space2,
						s_range,
						s_space3,
						s_value;	/* All are widths or heights */

static unsigned 		e_space1,
						e_end,
						e_space2,
						e_range,
						e_space3,
						e_buttons;	/* All are widths or heights */

#endif
						
void draw_number( eptr )
    HDR *eptr;
{

	FXY_AREA 				bbox_xy;
	RECT_AREA 				bbox;

	element = eptr;
    number = (NUMBER_ELEMENT *)element_ptr(element);

/*
flog("draw_number: ");
showsize(element);

    ElementInfo((char *)element + sizeof(HDR) , NULL , NULL , NULL,
		&pos);

	flog("Offset: %d %d\n",pos.row,pos.col);
*/
	
	pos.row = element->row;
	pos.col = element->col;

	/* Graphical object ? */
	if (number->format != 'T') gr = YES;
	else gr = NO;

	if (number->vertical || (number->format=='D') || (number->format=='M') ) vert = YES;
	else vert = NO;

	if (!vert) element->row -= element->height/2;

	display_number_info(number);

	if (gr)	number_graphics_init();

	/* do not actually print number elements in frame */
	if( flags & STAT_FRAME )
		buf_io_ctrl( 0 );

    switch (number->format & 0xff) {
		case 'B': 	draw_number_bar();						break;
		case 'D':	draw_number_dial();						break;
		case 'G':	draw_number_gauge();					break;
		case 'M':	draw_number_meter();					break;
		case 'S':	draw_number_slider();		            break;
		case 'T':	draw_number_only_text();				break;
	}   
	
	if ( number->current_value && vert && gr ) draw_number_text();

	if ( number->delta_buttons ) draw_delta_buttons();

	if( flags & STAT_FRAME ) buf_io_ctrl( 1 );

	xy_map((IRECT_AREA *)&element->row,&elmt_xy);


#if 1

//..........Modif for enclose text by Guy Grimard at Multimeg............


//	i = find_font( element, text,text->face?text->string+strlen(text->string)+1:NULL );

	/* Determine text's bounding box (Add some extra room) */

	bbox.row = elmt_xy.y - (font[0].map.baseline/2) - PV(2);
	bbox.col = elmt_xy.x - PH(4);
	bbox.height = font[0].map.height; // + PV(2);
	bbox.width = elmt_xy.w + PH(6);


	/* ???? 13pt font is treated differently */
	if( i == 2 ) {
		bbox.row += PV(1);
		bbox.height -= PV(2);
	}

	xy_map( (IRECT_AREA *)&bbox, &bbox_xy );
	draw_options(element,&bbox_xy);
    draw_label(label,element,0);


//.......................................................................

#else

	draw_options(element,&elmt_xy);
    draw_label(label,element,0);

#endif
}

STATIC draw_number_text()
{
	int x_offset;
	text_number=1; //Modif by Guy Grimard(debug text_slider) 	

	if (number->real) 
		{
		if (!number->precision) number->precision = 3;
		if( number->precision < 0 )number->precision = 0;
     	sprintf(temp,"%%%d.%df",number->field_width,number->precision);          
	    sprintf(value_str,temp,REALVAL.x);                                  
	 	} 
	else 
		{                                                                
     	sprintf(temp,"%%%dld",number->field_width);                              
     	sprintf(value_str,temp,INTVAL.n);                                   
 		}                                                                       
                                                                  
	if ( !gr && number->size<strlen(value_str) ) value_str[number->size] = '\0';                                   	
                                                                  
 	temp_area.height = 0;                                                   
	temp_area.width = font[i].map.width * strlen(value_str);  	

	if ( !gr || vert ) x_offset = temp_area.width;
	else x_offset = temp_area.width;

	if (vert) temp_area.col = pos.col + element->width/2 - (font[i].map.width * strlen(trim(value_str)))/2;
	else temp_area.col = pos.col;

 	temp_area.row = pos.row + font[i].map.baseline/2;

	/* Display value to the left */ 
	if ( gr && !vert ) 
		{
		element->col  -= x_offset;
		temp_area.col  = element->col;
		pos.col		  -= x_offset;
		}
                                                                  
 	i = find_font( element, NULL, NULL );                        
 	xy_map(&temp_area,&elmt_xy);                                       

//..........Modif for debug slider by Guy Grimard at Multimeg............

	if (vert)
		{ 
		elmt_xy.x=elmt_xy.x-100;    //vertical letter ajust position
		elmt_xy.y=elmt_xy.y+100;
		}
	else						    //horizontal letter ajust position
		{
		elmt_xy.x=elmt_xy.x;   //-100;
		elmt_xy.y=elmt_xy.y+50;
		}

#if 0
	if (vert) pos.row += font[i].map.height + 80;
	else pos.col += x_offset;
#endif

//.......................................................................

    draw_text( value_str, &elmt_xy, element->color, element,(TEXT_ELEMENT *)number, i );											        
	text_number=0;	
}

STATIC draw_number_bar()
{
/*
	number_colors_info(number);   
*/
	if ( !num_width ) num_width = 100;


	if (!element->color) element->color = BLACK;
	if (!element->fill) element->fill = BLACK;

	if ( vert )
		pos.col -= num_width/2;
	else
		pos.row -= num_width/2;

	if ( number_linear_size() )
		draw_rect(&elmt_xy,element->color,element->fill,0,H_TPP,element->pattern);

	number_linear_ticks();
	number_linear_displace();
}

STATIC draw_number_dial()
{
	int r;
	int x1, y1;

/*
	number_colors_info(number);
*/

	r = number_circle_size();

	if( number->outline ) {	
		hdr_printf( 0, 0, H_TPP, element->color, number->bkgd, 0 );
		buf_printf( "%d %d %d %d %d %d ",
			elmt_xy.x, elmt_xy.y , r, 360, 0, 1);
		name_printf( "A", 0 );
	}

	number_angle( percent, &x1, &y1, r );
	number_circle_center( x1, y1 );
	number_circle_ticks( r );

	pos.row += 2 * r + PV(4);
}

STATIC draw_number_gauge()
{
/*
	number_colors_info(number);
*/


	if (vert) {
/*
		pos.col -= num_width/2;
*/
	} else {
		pos.row -= num_width/2;
	}


	number_linear_outline();
	draw_rect( &elmt_xy, element->color, TRANSPARENT, num_width/2, H_TPP, 0 );

	if (vert) {
		pos.row -= V_TPP;
	} else {
		pos.row += PV(2);
	}
	pos.col += PH(2);
	number->size -= 2 * (vert?V_TPP:H_TPP);
	num_width -= 4 * (vert?H_TPP:V_TPP);

	if( number_linear_size() ) {

		if (!element->fill) element->fill = BLACK;

		/* Just show little rounded button (upwards) */
		if (vert) {
			elmt_xy.y += elmt_xy.h;
			elmt_xy.h = num_width;
		} else
			elmt_xy.w = num_width;

		draw_rect( &elmt_xy, element->fill, element->fill, num_width/2, H_TPP,
			element->pattern );

		if( vert ) {
			temp_area.row -= num_width/2;
			temp_area.height += num_width/2; /* Negative number */
		} else {
			temp_area.col += num_width/2;
			temp_area.width -= num_width/2;
		}

		xy_map( &temp_area, &elmt_xy );
		draw_rect( &elmt_xy, element->fill, element->fill, 0, H_TPP,
			element->pattern );
	}
		
	if (vert)
		pos.row += PV(2);
	else
		pos.row -= PV(2);

	pos.col -= PH(2);
	number->size += 2 * (vert?V_TPP:H_TPP);
	num_width += 4 * (vert?H_TPP:V_TPP);

	number_linear_ticks();
	number_linear_displace();
}

STATIC draw_number_meter()
{
	int r;
	int x1, y1;

/*
	number_colors_info(number);
*/

	r = number_circle_size();

	hdr_printf( 0, 0, H_TPP, element->color, number->bkgd, 0 );

	buf_printf("%d %d %d %d %d %d ",
		elmt_xy.x, elmt_xy.y , r, 0, 180, 1);

	name_printf( "A", 0 );

	number_angle( percent, &x1, &y1, r );

	number_circle_center( x1, y1 );
	number_circle_ticks( r );

	pos.row += r + 70;
}

STATIC draw_number_slider()
{
	RECT_AREA area_tmp;
	memmove( &area_tmp, &element->row, sizeof(RECT_AREA) );

	if( vert ) {
		element->col += PH(num_width/2+3);
		num_width -= PH(6);
	} else {
		element->row += PV(num_width/2+3);
		num_width -= PV(6);
	}

/*
	number_colors_info(number);
*/
	number_linear_outline();
	draw_rect( &elmt_xy, element->color, TRANSPARENT, num_width/2, H_TPP, 0 );


	if ( !element->fill ) element->fill = BLACK;

	if ( number_linear_size() )
		draw_rect( &elmt_xy, element->fill, element->fill, num_width/2, H_TPP,element->pattern );
	if (vert) {
		element->col -= PH(num_width/2+3);
		num_width += PH(6);
	} else {
		element->row -= PV(num_width/2+3);
		num_width += PV(6);
	}

	number_slider_button();
	number_linear_ticks();
	number_linear_displace();
}

STATIC draw_number_only_text()
{
	if (!number->field_width)
		number->field_width = (unsigned char)number->size;

	draw_number_text();
	/* This could be used for label positioning */
	element->_row = temp_area.row;
}

/*--------------------------------------------
	number_linear_size:

	Determines linear number size (h&v)

	Returns: Fill area size
----------------------------------------------*/

STATIC number_linear_size()
{

	temp_area.col = pos.col;

	if (vert) {
/*
		temp_area.col -= PH(number->width) / 2;
*/
		temp_area.row = pos.row + number->size;
		temp_area.width = num_width;
		temp_area.height = - (int) round (percent * number->size);
	} else {
		temp_area.row = pos.row;/*- PV(number->width)/2;*/
		temp_area.height = num_width;
		temp_area.width = (int) (percent * number->size);
	}

	xy_map( &temp_area, &elmt_xy );

	return ( (int)(percent * number->size) );
}

/*--------------------------------------------
	number_linear_outline:

	Determines linear number outline (h&v)
	Sets elmt_xy to CTM

	Returns: number size
----------------------------------------------*/

STATIC number_linear_outline()
{
	temp_area.row = pos.row;
	temp_area.col = pos.col;

	if (vert) {
/*
		temp_area.col -= num_width/2;
*/
		temp_area.height = number->size;
		temp_area.width = num_width;
	} else {
/*
		temp_area.row -= num_width/2;
*/
		temp_area.height = num_width;
		temp_area.width = number->size;
	}

	xy_map( &temp_area, &elmt_xy );

	return( number->size );
}

STATIC number_circle_size()
{
	int r;
	
	r = number->size/2;

	temp_area.row = pos.row + r;
	temp_area.col = pos.col + r;
	temp_area.height = temp_area.width = 0;

	xy_map( &temp_area, &elmt_xy );

	return( r );
}


/*----------------------------------------
	Add graphical linear number element's
	offset to 'pos'
------------------------------------------*/

STATIC number_linear_displace()
{
	if ( vert )
		pos.row += number->size + 100;
	else
		pos.col += number->size + 100;
}

STATIC number_graphics_init()
{
    if (number->real)
        percent = (REALVAL.x-REALVAL.start)/(REALVAL.end-REALVAL.start);
    else
        percent = (float)(INTVAL.n-INTVAL.start)/(INTVAL.end-INTVAL.start);

	if ( percent>1.0 ) percent = 1.0;
	if ( percent<0.0 ) percent = 0.0;

	/* Default for graphical numbers */
	if ( !number->field_width ) number->field_width = 4;

	if ( vert )
		num_width = PH( number->width );
	else
		num_width = PV( number->width );

/*
	if (!element->color)
		element->color = number->color;
*/

	if ( number->current_value && !vert )
		draw_number_text();
}

STATIC display_number_info(number)
	NUMBER_ELEMENT *number;
{
	if ( !( options & OPT_VERBOSE ) ) return ( 0 );

	flog("Format: %c Size: %d Size2: %d Precision: %d\n",number->format,
		number->size,number->size2,number->precision);
	flog("Width: %u Field w: %d\n",number->width,number->field_width);
	flog("Sub row %u col %u\n",number->row,number->col);
	if (number->real)
		flog(" x %f start %f end %f\n",REALVAL.x,REALVAL.min,REALVAL.max);
	else
		flog(" n %ld start %ld end %ld\n",INTVAL.n,INTVAL.min,INTVAL.max);
	return( 1 );
}

STATIC number_colors_info( number )
	NUMBER_ELEMENT *number;
{
	if ( !( options & OPT_VERBOSE ) ) return ( 0 );

	flog("Color: %u Bkgd: %u Button: %u Slider: %u Tick: %u\n",
		number->color,number->bkgd,number->button,number->slider,number->tick);
	flog("Dial: %u Label: %u Limit: %u Text: %u\n",number->dial,
		number->label,number->limit,number->text);
	flog("Element: col %u fill %u\n",element->color,element->fill);
	return( 1 );
}

STATIC number_circle_center( x1, y1 )
	int x1, y1;
{
	float diff;
	int x2, y2, x3, y3;

	if( number->format == 'M' )
		diff = 0.5;
	else
		diff = 0.25;

	number_angle( percent - diff, &x2, &y2, PH(2) );
	number_angle( percent + diff, &x3, &y3, PH(2) );

	buf_printf("%s %d %d %d %d %d %d triangle\n",ps_colour(element->color),
		x1, y1, x2, y2, x3, y3 );

	if (!number->dial)
		number->dial = element->color;

	hdr_printf( 0, 0, H_TPP, number->dial, number->dial, 0 );

	buf_printf("%d %d %d %d %d %d ",
		elmt_xy.x, elmt_xy.y , 30, 0, 360, 1 );

	name_printf( "A", 0 );
	return( 1 );
}

STATIC number_linear_ticks()
{
	int offset;

	if (!number->ticks)
		return(0);

	offset = number->size/(number->n_ticks - 1);
	if (number->vertical)
		draw_H_ticks(offset);
	else
		draw_V_ticks(offset);
	return( 1 );
}


STATIC draw_H_ticks( offset )
	int offset;
{
	IRECT_AREA area;

	area.col = pos.col + num_width + PH(8);
	area.row = pos.row + number->size;
	area.height = PH(4);
	area.width = 0;

	xy_map( &area, &elmt_xy );

	buf_printf( "0 %d %u { Gs 0 exch Tr\n",	offset, number->size );
	buf_printf("	%d %d %d Htick\n",elmt_xy.h,elmt_xy.x,elmt_xy.y);
	buf_printf("Gr } for\n");
	return( 1 );
}


STATIC draw_V_ticks ( offset )
	int offset;
{
	IRECT_AREA area;

	area.col = pos.col;
	area.row = pos.row + num_width + PV(10);
	area.height = 0;
	area.width = PV(4);

	xy_map( &area, &elmt_xy );

	buf_printf("0 %d %u { Gs 0 Tr \n", offset, number->size );
	buf_printf("%d %d %d Vtick\n",elmt_xy.w,elmt_xy.x,elmt_xy.y);
	buf_printf("Gr } for\n");
	return( 1 );
}

STATIC number_circle_ticks( r )
	unsigned r;
{
	int i;
	unsigned rp;
	int x1, y1, x2, y2;
	float x, d;
	float angle;

	if ( !number->ticks )
		return(0);

	/* Move out one 'pixel' */
	r -= H_TPP;

	/* If only 1/2 circle 1 less gap */
	if (number->format == 'M')
		d = 1.0 / ( number->n_ticks - 1 );
	else
		d= 1.0 / number->n_ticks;

	/* Inner radius */
	rp = r - PH(4);
	
	if( !number->tick ) number->tick = element -> color;

	/* Scales don't always start at 0... */
	if( number->n_ticks % 2 )
		x = d / 2.0;
	else
		x = 0.0;

	for( i=1; i<=number->n_ticks; i++ , x += d ) {
		buf_printf( "0 0 1 %s ", ps_colour(number->tick) );		
		angle = number_angle( x, &x1, &y1, r );
		x2 = (int)( cos(angle) * rp )+ elmt_xy.x;
		y2 = elmt_xy.y - (int)( sin(angle) * rp );
		buf_printf("%d %d %d %d line\n", x1, y1, x2, y2);
	}
	return( 1 );
}

STATIC float number_angle( percent, x1, y1, r )
	float percent;
	int *x1, *y1, r;
{
	float angle;

	if( number->format == 'D' )
		angle = ( 1.0 - percent ) * (2.0 * PI ) + PI;
    else
		angle = ( 1.0 - percent ) * PI;

	*x1 = (int)( cos(angle) * r ) + elmt_xy.x;
	*y1 = elmt_xy.y - (int)( sin(angle) * r );

	return( angle );
}


STATIC draw_delta_buttons()
{
	FXY_AREA xy;
	int coeficient; //modif for debug slider by Guy Grimard at Multimeg.	

	if( !number->vertical )
		temp_area.col = pos.col + 50;

	temp_area.row = pos.row - VERT_H/2;
	pxy_map(&xy.x,&xy.y,temp_area.col,temp_area.row);


//..........Modif for debug slider by Guy Grimard at Multimeg............

	if( number->vertical ) //..........Slider vertical...............
		{

		//Evaluate the size of number and ajust position		
	
		if ((INTVAL.n/10)<1) coeficient=140;
		else if ((INTVAL.n/10)>10) coeficient=50;
		else coeficient=100;

		// Button down of slider
	
		if (text_number) buf_printf( "%d %d down\n", xy.x-coeficient, xy.y+180);
		else buf_printf( "%d %d down\n", xy.x-50, xy.y+250);

		// Button up of slider

		temp_area.row += 100;
		xy.y -= PV(11);

		if (text_number) buf_printf( "%d %d up\n", xy.x-coeficient, xy.y+180);
		else buf_printf( "%d %d up\n", xy.x-50, xy.y+250);

		text_number=0;	
		}
  else 		//.................Slider horizontale.................
		{
		xy.y -= PV(4);
		xy.x += PH(56);
		buf_printf( "%d %d down\n", xy.x, xy.y );
		temp_area.col += 110;
		xy.x += PH(12);
		buf_printf( "%d %d up\n", xy.x, xy.y );
		}
//.......................................................................

}

STATIC number_slider_button()
{
    IRECT_AREA area;
	FXY_AREA xy;

	if( !vert ) {
		area.row = element->row - PV(2);
		area.col = pos.col - PH(4) + (unsigned)(number->size*percent);
		area.height = num_width;
		area.width  = PH(8);
	} else {

//..........Modif for debug slider by Guy Grimard at Multimeg............
	
		//Redraw the vertical position of the moving button on the slider
		percent=1.0-percent; 

//.......................................................................

		area.row = element->row - PH(4) + (unsigned)(percent*number->size);
		area.col = pos.col;
		area.height = PV(8);
		area.width  = num_width;
	}

	xy_map( &area, &xy );

//..........Modif for debug slider by Guy Grimard at Multimeg............

	//Ajust the  horizontal position of the moving button on the slider
	xy.x-=30;

//.......................................................................

	draw_rect( &xy, LIGHT_GRAY, LIGHT_GRAY, 0, H_TPP, 0 );
	buf_printf( "%d %d %d %d Omod\n", xy.w, xy.h, xy.x, xy.y);
}
	

	
