/***********************************************************
    PROGRAM:    pictps
    MODULE:     pictps_proto.h

    AUTHOR:     Patrick Hayden
    DATE:       1992-03-07
***********************************************************/

#include <ctype.h>

extern bool isprintable(char *);
extern char *element_ptr(struct element_hdr *);
extern struct extra_element_data *data_ptr(struct element_hdr *);
extern LABEL_DATA *label_ptr(ELEMENT_DATA *);
extern TRANSFORM_DATA *transform_ptr(ELEMENT_DATA *);
extern int query_map_rgb(void);
extern int query_font_info(void);
extern int query_pict_size( char * );
extern int open_graphics( int );
extern void draw_symbol(struct element_hdr *,struct symbol_element *,struct fxy_area *);
extern void draw_image(struct element_hdr *,struct image_element *);
extern char *buf_puts(char *);
extern void buf_io_ctrl(int);
extern int buf_printf(char *,... );
extern int determine_file_type( FILE * );
extern void buf_strcat(char *);
extern void flush_buffer(void );
extern unsigned short get_file_extension(void );
extern char *make_temp_file( void );
extern void error(char *,... );
extern int flog(char *,... );
extern int resolve_link(struct element_hdr *,struct link_element *);
extern void draw_link(char *,struct element_hdr *,struct link_element *);
extern void draw_shadow( struct element_hdr *, unsigned short );
extern void draw_options(struct element_hdr *,struct fxy_area *);
extern int draw_label(struct label_data *,struct element_hdr *, unsigned);
extern void x_position_label(struct element_hdr *,struct label_data *,struct area_dat *,union ufont *,char *);
extern void y_position_label(struct element_hdr *,struct label_data *,struct area_dat *,union ufont *,unsigned);
extern int draw_transform_start( void );
extern int draw_transform_end( void );
extern int draw_line_style_start(struct line_element *);
extern int draw_line_style_end(struct line_element *);
extern int rgb_printf(struct rgb *);
extern int hdr_printf(int ,int ,unsigned int ,int ,int ,int );
extern int name_printf(char *,int );
extern int find_font(struct element_hdr *, struct text_element *, char *);
extern void draw_rect(struct fxy_area *,unsigned int ,unsigned int ,unsigned int ,unsigned int ,int );
extern void draw_rect_mod(struct fxy_area *, unsigned int, unsigned int, unsigned int);
extern void draw_hscroll(struct fxy_area *);
extern void draw_vscroll(struct fxy_area *);
extern void draw_text(char *,struct fxy_area *,unsigned int ,struct element_hdr *,struct text_element *,int );
extern void boxclip_start(struct fxy_area *);
extern void bevelclip_start(struct fxy_area *, unsigned);
extern void clip_end(void);
extern void get_points(unsigned int ,struct point_data *,unsigned int ,unsigned int *,unsigned int *);
extern unsigned get_window_options(struct wind_struct *,char *,char **);
extern char *strformat(char *);
extern char *StrTok( char * );
extern char *ps_colour(int);
extern char *trim(char *);
extern char *salloc(unsigned int );
extern void showsize(struct element_hdr *);
extern void draw_number(struct element_hdr *);
extern double round ( double );
extern int def_xy_map(unsigned int ,unsigned int );
extern void push_offset();
extern void pop_offset();
extern void add_offset(struct area_data *);
extern void sub_offset(struct area_data *);
extern void clear_offset(void);
extern void xy_map(struct area_dat *,struct fxy_area *);
extern void pxy_map(int *,int *,int ,int );
extern void ps_write_hdr(void);
extern void ps_write_trailer(void);
extern void ps_write_colour_map(void);
extern void ps_draw_bkgd(struct file_hdr *);
extern int Draw_element(struct element_hdr *);
extern void Draw_arc(struct element_hdr *);
extern void Draw_button(struct element_hdr *);
extern void Draw_curve(struct element_hdr *);
extern void Draw_group(struct element_hdr *);
extern void Draw_end_group(struct element_hdr *);
extern void Draw_image(struct element_hdr *);
extern void Draw_line(struct element_hdr *);
extern void Draw_link(struct element_hdr *);
extern void Draw_meta(struct element_hdr *);
extern void Draw_msgs(struct element_hdr *);
extern void Draw_number(struct element_hdr *);
extern void Draw_para(struct element_hdr *);
extern void Draw_path(struct element_hdr *);
extern void Draw_points(struct element_hdr *);
extern void Draw_rect(struct element_hdr *);
extern void Draw_symbol(struct element_hdr *);
extern void Draw_text(struct element_hdr *);
extern int Set_coords(struct element_hdr *);
extern void Init_coords(void);
extern main(int ,char **);
extern int link_open(char *);
