/****************************************************************************

	File:		wind_file.h
	Author:		Frank Kolnick
	Created:	88/10/23

	$Header$

	(c) 1988 copyright Basis Computer Systems Inc.
	All rights reserved.


*****************************************************************************/

#ifndef _WIND_FILE_H
#define	_WIND_FILE_H

/* File header: */


#define	MAX_PICTURE_BLOCK	2000
#define	PICTURE_HDR_SIZE	200
#define	PICTURE_HDR_ID		"QUIP\01\01\02\03FK"


typedef struct file_hdr
{
	char		id[12];					/* PICTURE_HDR_ID */
	unsigned	version;				/* server version no. (xx.y.zz) */
	unsigned	picture:1;				/* 'picture file' */
	unsigned	window:1;				/* 'window file' */
	unsigned	values:1;				/* 'default value file' */
	unsigned	pane:1;					/* 'contains picture(s) for pane(s)' */
	/* FK 6/7 */
	unsigned	grid:1;					/* 'contains grid spec.' */
	unsigned	color:1;				/* 'contains local color table' */
	unsigned	font:1;					/* 'contains local font table' */
	unsigned	_rsv_file:8;			/* (reserved) */
	unsigned	bkgd;					/* background color */
	unsigned	pattern;				/* background pattern */
	int			n_pictures;				/* #pictures in this file */
	char		title[102];				/* default title */
	unsigned	height, width;			/* initial size */
	char		type[MAX_TYPE_LEN+1];	/* picture type */
	unsigned	bkgd2;					/* pattern background color */
	char		_rsv_file2[22];			/* (reserved) */
	HIGH_LIGHT	highlighting;			/* highlighting options */
	int			context_size;			/* #bytes in context record, if present;
										   context immediately follows header */
	unsigned	largest;				/* size of largest element */
} PICTURE_HDR;

#endif

